/************************************************************************/
/*									*/
/* fBXNC[W̃wb_̏ (ǂݏ)				*/
/*									*/
/************************************************************************/

#include <stdio.h>
#include <string.h>

#include "quasi88.h"
#include "initval.h"
#include "drive.h"
#include "image.h"
#include "file-op.h"





/************************************************************************/
/* w肳ꂽC[W̐擪t@CʒuAwb_ǂݏoB	*/
/*		FILE *fp	t@C|C^			*/
/*		long offset	C[W̐擪̃t@Cʒu		*/
/*		Uchar header[32] wb_̊i[			*/
/*	Ԃl	0	I					*/
/*		1	ȏC[W				*/
/*		2	C[Wُ(wb_jATCYs)		*/
/*		3	V[NG[					*/
/*		header[32] ɂ́AC[W̃wb_̓eB		*/
/*		ȂAG[́Aheader[]̓e͕sB		*/
/************************************************************************/
int	fread_header( FILE *fp, long offset, Uchar header[32] )
{
  long	size;
  char	c;

  if( ex_fseek( fp, offset,  SEEK_SET ) ) return 4;	/* Seek Error */

  size =ex_fread( header, sizeof(Uchar), 32, fp );
  if( size==0 )  return 1;				/* File End */
  if( size!=32 ) return 2;				/* Header Broken */


  size = read_size_in_header( header );

  if( ex_fseek( fp, offset+size-1, SEEK_SET ) ) return 3;	/* Seek Error */

  if(ex_fread( &c, sizeof(char), 1, fp )!=1 ) return 2;	/* Image Broken */

  return 0;
}






/************************************************************************/
/* w肳ꂽ[hŃt@CJB					*/
/*	hCuɐݒ肳Ăt@C̏ꍇÃ|C^ԂB	*/
/*	łȂꍇ́At@CJẴ|C^Ԃ		*/
/*		char *filename	t@C				*/
/*		char *mode	[h ("r+","w+","a")			*/
/*		int *result	ʂԂ[N			*/
/*	Ԃl	|C^	t@C|C^			*/
/*				NULL̏ꍇ́AG[B		*/
/*		*resultɂ̓|C^܂̓G[ʂ		*/
/*		펞)							*/
/*			*result==-1 c VKɃt@CI[v		*/
/*			*result== 0 c hCu 0: ̃t@CI[v	*/
/*			*result== 1 c hCu 1: ̃t@CI[v	*/
/*		ُ펞)							*/
/*			*result==-1 c t@C̃I[vG[		*/
/*			*result== 0 c hCu 0: ̃t@CBǍp	*/
/*			*result== 1 c hCu 1: ̃t@CBǍp	*/
/************************************************************************/
FILE	*fopen_image_edit( char *filename, char *mode, int *result )
{
  if      ( drive[0].fp   &&
	    osd_file_cmp( drive[0].filename, filename )==FILE_CMP_OK ){
    *result = 0;
  }else if( drive[1].fp   &&
	    osd_file_cmp( drive[1].filename, filename )==FILE_CMP_OK ){
    *result = 1;
  }else{
    *result = -1;
  }

  switch( *result ){
  case -1:
    return ( ex_fopen( filename, mode ) );
  case 0:
  case 1:
    if( drive[ *result ].read_only ) return NULL;
    else                             return drive[ *result ].fp;
  default:
    printf("Internal Error in fopen_image_edit()\n");
    return NULL;
  }
}




/************************************************************************/
/* w肳ꂽC[W̍ŌɁAuNfBXÑC[WǉB	*/
/*	ǉ̂́A2D ̃fBXNB2DD/2HD ͖Ή			*/
/*		FILE *fp	t@C|C^			*/
/*	Ԃl	0	I					*/
/*		3	V[NG[					*/
/*		4	CgG[					*/
/************************************************************************/
int	append_blank( FILE *fp )
{
  char *s, c[256];
  int	i, j, error = 0;
  int	type = DISK_TYPE_2D;
  int	trk_nr, trk_size, img_size;

  switch( type ){
  case DISK_TYPE_2HD:
    trk_nr   = 164;
    trk_size = 0x2300;
    break;
  case DISK_TYPE_2DD:
    trk_nr   = 164;
    trk_size = 0x1600;
    break;
  case DISK_TYPE_2D:
  default:
    type     = DISK_TYPE_2D;
    trk_nr   = 84;
    trk_size = 0x1600;
    break;
  }
  img_size = (32) + (164*4) + (trk_nr*trk_size);


  if( (ex_fseek( fp, 0,  SEEK_END )) ){
    error = 3;
  }

	/* wb_ */

  if( error==0 ){
    s = &c[0];
    for(i=0;i<17;i++) *s++ = 0;		/* filename */
    for(i=0;i<9;i++)  *s++ = 0;		/* reserved */
    *s++ = DISK_PROTECT_FALSE;		/* protect  */
    *s++ = type;			/* type     */
    *s++ = (img_size >>  0) & 0xff;	/* size     */
    *s++ = (img_size >>  8) & 0xff;
    *s++ = (img_size >> 16) & 0xff;
    *s++ = (img_size >> 24) & 0xff;
    if(ex_fwrite( c, sizeof(Uchar), 32, fp )!=32 ){
      error = 4;
    }
  }

	/* gbN */

  if( error==0 ){
    j = 0x2b0;				/* size of track data */
    for(i=0;i<164;i++){
      if( i<trk_nr ){
	c[0] = (j >>  0)&0xff;
	c[1] = (j >>  8)&0xff;
	c[2] = (j >> 16)&0xff;
	c[3] = (j >> 24)&0xff;
	j += trk_size;
      }else{
	c[0] = c[1] = c[2] = c[3] = 0;
      }
      if(ex_fwrite( c, sizeof(Uchar), 4, fp )!=4 ) break;
    }
    if( i!=164 ){
      error = 4;
    }
  }

	/* ZN^ */

  if( error==0 ){
    for( i=0; i<256; i++ ) c[i] = 0;	/* sec data */
    for( i=0; i<trk_nr*trk_size; ){
      if( trk_nr*trk_size - i < 256 ) j = trk_nr*trk_size - i;
      else                            j = 256;
      if(ex_fwrite( c, sizeof(Uchar), j, fp )!=(size_t)j ) break;
      i += j;
    }
    if( i!=trk_nr*trk_size ){
      error = 4;
    }
  }

  fflush( fp );
  return error;
}


/************************************************************************/
/* uNfBXÑC[WǉAdrive[][NXVB	*/
/*		int drv		hCuԍ				*/
/*	Ԃl	Ȃ							*/
/************************************************************************/
void	update_after_append_blank( int drv )
{
  int	i, img;
  int	repeat = (drive[0].fp==drive[1].fp) ? 2 : 1;
  int	type = DISK_TYPE_2D;
  int	img_size;

  switch( type ){
  case DISK_TYPE_2HD:
    img_size = 164 * 0x2300;
    break;
  case DISK_TYPE_2DD:
    img_size = 164 * 0x1600;
    break;
  case DISK_TYPE_2D:
  default:
    type     = DISK_TYPE_2D;
    img_size = 84 * 0x1600;
    break;
  }
  img_size += (32) + (164*4);


  for( i=0; i < repeat; i++ ){

    if( !drive[ drv ].detect_broken_image ){

      drive[ drv ].file_size += img_size;
      if( drive[ drv ].image_nr + 1 <= MAX_NR_IMAGE ){
	img = drive[ drv ].image_nr;
	drive[drv].image[img].name[0] = '\0';
	drive[drv].image[img].protect = DISK_PROTECT_FALSE;
	drive[drv].image[img].type    = type;
	drive[drv].image[img].size    = img_size;
	drive[ drv ].image_nr ++;
      }else{
	drive[ drv ].over_image = TRUE;
      }

    }
    drv ^= 1;
  }

}


/************************************************************************/
/* w肳ꂽC[Wԍ́AveNgB		*/
/*		FILE *fp	t@C|C^			*/
/*		int  img	C[Wԍ				*/
/*		char protect    veNg				*/
/*	Ԃl	0	I					*/
/*		1	wԍ̃C[W				*/
/*		2	C[Wُ(wb_jATCYs)		*/
/*		3	V[NG[					*/
/*		4	CgG[					*/
/*		5	C[WI[o[				*/
/************************************************************************/
int	fwrite_protect( FILE *fp, int img, char *protect )
{
  Uchar	c[32];
  long	offset = 0;
  int	num = 0, result;

  while( (result=fread_header( fp, offset, c ) ) == 0 ){

    if( img == num ){
      if( ex_fseek( fp, offset+DISK_PROTECT, SEEK_SET )==0 ){
	if(ex_fwrite( protect, sizeof(char), 1, fp)==1 ){
	  /* success */
	}
	else result = 4;
      }else  result = 3;
      break;
    }

    num ++;
    offset += read_size_in_header( c );

    if( offset < 0 || num > 256 ){
      result = 5;
      break;
    }
  }
  fflush( fp );
  return result;
}
/************************************************************************/
/* veNg[N̍XVAdrive[][NXVB			*/
/*		int drv		hCuԍ				*/
/*	Ԃl	Ȃ							*/
/************************************************************************/
void	update_after_fwrite_protect( int drv, int img, char *protect )
{
  int	i;
  int	repeat = (drive[0].fp==drive[1].fp) ? 2 : 1;

  if( img < MAX_NR_IMAGE ){

    for( i=0; i < repeat; i++ ){

      drive[ drv ].image[ img ].protect = *protect;
      if( drive[ drv ].selected_image == img ){
	drive[ drv ].protect = *protect;
	if( drive[ drv ].read_only ) drive[ drv ].protect = DISK_PROTECT_TRUE;
      }

      drv ^= 1;
    }
  }
}



/************************************************************************/
/* w肳ꂽC[Wԍ́AC[W̖OB		*/
/*		FILE *fp	t@C|C^			*/
/*		int  img	C[Wԍ				*/
/*		char *name      C[Wl[(16)			*/
/*	Ԃl	0	I					*/
/*		1	wԍ̃C[W				*/
/*		2	C[Wُ(wb_jATCYs)		*/
/*		3	V[NG[					*/
/*		4	CgG[					*/
/*		5	C[WI[o[				*/
/************************************************************************/
int	fwrite_name( FILE *fp, int img, char *name )
{
  Uchar	c[32];
  long	offset = 0;
  int	num = 0, result;

  while( (result=fread_header( fp, offset, c ) ) == 0 ){

    if( img == num ){
      strncpy( (char *)c, name, 16 );
      c[16] = '\0';
      if( ex_fseek( fp, offset+DISK_FILENAME, SEEK_SET )==0 ){
	if(ex_fwrite( c, sizeof(Uchar), 17, fp)==17 ){
	  /* success */
	}
	else result = 4;
      }else  result = 3;
      break;
    }

    num ++;
    offset += read_size_in_header( c );

    if( offset < 0 || num > 256 ){
      result = 5;
      break;
    }
  }
  fflush( fp );
  return result;
}
/************************************************************************/
/* C[W̖O̍XVAdrive[][NXVB			*/
/*		int drv		hCuԍ				*/
/*	Ԃl	Ȃ							*/
/************************************************************************/
void	update_after_fwrite_name( int drv, int img, char *name )
{
  int	i;
  int	repeat = (drive[0].fp==drive[1].fp) ? 2 : 1;

  if( img < MAX_NR_IMAGE ){

    for( i=0; i < repeat; i++ ){

      strncpy( drive[ drv ].image[ img ].name, name, 17 );

      drv ^= 1;
    }
  }
}



/************************************************************************/
/* w肳ꂽC[Wԍ́AC[WAtH[}bgԂɂB	*/
/*		FILE *fp	t@C|C^			*/
/*		int  img	C[Wԍ				*/
/*	Ԃl	0	I					*/
/*		1	wԍ̃C[W				*/
/*		2	C[Wُ(wb_jATCYs)		*/
/*		3	V[NG[					*/
/*		4	CgG[					*/
/*		5	C[WI[o[				*/
/************************************************************************/
int	fwrite_unformat( FILE *fp, int img )
{
  Uchar	c[256];
  long	offset = 0, st, sz, len;
  int	num = 0, result, i;

  while( (result=fread_header( fp, offset, c ) ) == 0 ){

    if( img == num ){
      sz = read_size_in_header( c );
      if( ex_fseek( fp, offset+DISK_TRACK, SEEK_SET )==0 ){
	if(ex_fread( c, sizeof(Uchar), 4, fp)==4 ){
	  st = ((long)c[0]+((long)c[1]<<8)+((long)c[2]<<16)+((long)c[3]<<24));
	  if( ex_fseek( fp, offset+st, SEEK_SET )==0 ){
	    for( i=0; i<256; i++ ) c[i] = 0x00;
	    if( DISK_TRACK+4 <= st && st < sz ){
	      while( st < sz ){
		if( sz - st < 256 ) len = sz - st;
		else                len = 256;
		if(ex_fwrite( c, sizeof(Uchar), len, fp )==(size_t)len ){
		  /* seccess */
		}
		else result = 4;
		if( result ) break;
		st += len;
	      }
	    }else result = 2;
	  }else   result = 3;
	}
	else result = 4;
      }else  result = 3;
      break;
    }

    num ++;
    offset += read_size_in_header( c );

    if( offset < 0 || num > 256 ){
      result = 5;
      break;
    }
  }
  fflush( fp );
  return result;
}



/************************************************************************/
/* w肳ꂽC[Wԍ́AC[WtH[}bgB		*/
/*	2D ́AN88-BASIC f[^fBXNƂătH[}bgsȂB	*/
/*		FILE *fp	t@C|C^			*/
/*		int  img	C[Wԍ				*/
/*	Ԃl	0	I					*/
/*		1	wԍ̃C[W				*/
/*		2	C[Wُ(wb_jATCYs)		*/
/*		3	V[NG[					*/
/*		4	CgG[					*/
/*		5	C[WI[o[				*/
/************************************************************************/

#define	generate_sector_data()					\
	do{							\
	  if( trk==37 && sec==13 ){				\
	    i = 1;						\
	  }else if( trk==37 && (sec==14||sec==15||sec==16) ){	\
	    i = 2;						\
	  }else{						\
	    i = 0;						\
	  }							\
	  d[i][ DISK_C ] = trk >> 1;				\
	  d[i][ DISK_H ] = trk & 1;				\
	  d[i][ DISK_R ] = sec;					\
	  d[i][ DISK_N ] = 1;					\
	  d[i][ DISK_SEC_NR +0 ] = 16 >> 0;			\
	  d[i][ DISK_SEC_NR +1 ] = 16 >> 8;			\
	  d[i][ DISK_DENSITY ] = DISK_DENSITY_DOUBLE;		\
	  d[i][ DISK_DELETED ] = DISK_DELETED_FALSE;		\
	  d[i][ DISK_STATUS ] = 0;				\
	  d[i][ DISK_SEC_SZ +0 ] = ((256) >> 0) & 0xff;		\
	  d[i][ DISK_SEC_SZ +1 ] = ((256) >> 8) & 0xff;		\
	}while(0)

int	fwrite_format( FILE *fp, int img )
{
  Uchar	c[32];
  Uchar	d[3][ 16 + 256 ];
  long	offset = 0, st, sz;
  int	num = 0, result, trk, sec;

  int	i;
  for( i=0; i<16;  i++ ) d[ 0 ][ i ] = 0x00;
  for( i=0; i<256; i++ ) d[ 0 ][ 16 +i ] = 0xff;
  for( i=0; i<16;  i++ ) d[ 1 ][ i ] = 0x00;
  for( i=0; i<256; i++ ) d[ 1 ][ 16 +i ] = 0x00;
  for( i=0; i<16;  i++ ) d[ 2 ][ i ] = 0x00;
  for( i=0; i<160; i++ ) d[ 2 ][ 16 +i ] = 0xff;
  for(    ; i<256; i++ ) d[ 2 ][ 16 +i ] = 0x00;
  d[ 2 ][ 16 +37*2    ] = 0xfe;
  d[ 2 ][ 16 +37*2 +1 ] = 0xfe;

  while( (result=fread_header( fp, offset, c ) ) == 0 ){

    if( img == num ){
      sz = read_size_in_header( c );
      c[ 0 ] = DISK_TYPE_2D;
      if( ex_fseek( fp, offset+DISK_TYPE, SEEK_SET )==0 ){
	if(ex_fwrite( c, sizeof(Uchar), 1, fp)==1 ){		/* 2D ɐݒ */
	  for( trk=0; trk<80; trk++ ){
	    if( ex_fseek( fp, offset+(DISK_TRACK+trk*4), SEEK_SET )==0 ){
	      if(ex_fread( c, sizeof(Uchar), 4, fp)==4 ){
		st =  (long)c[0]     +((long)c[1]<<8)
		    +((long)c[2]<<16)+((long)c[3]<<24);
		if( ex_fseek( fp, offset+st, SEEK_SET )==0 ){
		  if( DISK_TRACK+80*4 <= st && st+(16+256)*16 <= sz ){
		    for( sec=1; sec<=16; sec++ ){
		      generate_sector_data();
		      if(ex_fwrite( d[i], sizeof(Uchar), 16+256, fp )==16+256 ){
			/* seccess */
		      }
		      else result = 4;
		      if( result ) break;
		    }
		  }
		  else result = 2;
		}else  result = 3;
	      }
	      else result = 2;
	    }else  result = 3;
	    if( result ) break;
	  }
	}
	else result = 4;
      }else  result = 3;
      break;
    }

    num ++;
    offset += read_size_in_header( c );

    if( offset < 0 || num > 256 ){
      result = 5;
      break;
    }
  }
  fflush( fp );
  return result;
}



/************************************************************************/
/* C[W̃tH[}bgAdrive[][NXVB			*/
/*		int drv		hCuԍ				*/
/*	Ԃl	Ȃ							*/
/************************************************************************/
void	update_after_fwrite_format( int drv, int img )
{
  int	i;
  int	repeat = (drive[0].fp==drive[1].fp) ? 2 : 1;

  if( img < MAX_NR_IMAGE ){

    for( i=0; i < repeat; i++ ){

      drive[ drv ].image[ img ].type = DISK_TYPE_2D;

      drv ^= 1;
    }
  }
}
