#ifndef GRAPH_H_INCLUDED
#define GRAPH_H_INCLUDED


extern	int	WIDTH;			/* EBhETCY		*/
extern	int	HEIGHT;			/* EBhEcTCY		*/
extern	int	DEPTH;			/* Frbg	(8/16/32)	*/
extern	int	SCREEN_W;		/* ʉTCY (320/640/1280)	*/
extern	int	SCREEN_H;		/* ʏcTCY (200/400/800)	*/
extern	int	SCREEN_DX;
extern	int	SCREEN_DY;
extern	int	VIEWPORT_W;
extern	int	VIEWPORT_H;
extern	int	VIEWPORT_DX;
extern	int	VIEWPORT_DY;
extern	int	SCREEN_OFFSET;
extern	Ulong	black;


enum {
  SCREEN_SIZE_HALF,
  SCREEN_SIZE_FULL,
  SCREEN_SIZE_DOUBLE,
  END_of_SCREEN_SIZE
};
extern	int	screen_size;		/* ʃTCY 0:W/1:/2:{*/
extern	int	screen_size_max;

extern	char	*screen_buf;		/* \pobt@ 	 	*/
					/* 640x400 or 320x200		*/
					/* 8(char)or16(short)or32(long)	*/

extern	char	*screen_start;		/* \obt@`Jnʒu	*/


extern	int	hide_mouse;		/* }EX\邩ǂ	*/
extern	int	grab_mouse;		/* Ou邩ǂ		*/

extern	Ulong	color_pixel[16];	/* 16pbgpixell	*/
extern	Ulong	color_half_pixel[16][16];	/* halfTCYp
						   tB^pbgl	*/


extern	int	colormap_type;		/* J[}bṽ^Cv	0/1/2	*/
#ifdef MITSHM
extern	int	use_SHM;		/* MIT-SHM gp邩ǂ	*/
#endif
#ifdef USE_DGA
extern	int	use_DGA;		/* XF86-DGA gp邩ǂ	*/
extern	int	enable_DGA;		/* XF86-DGA gpǂ	*/
extern	int	restart_DGA;		/* XF86-DGA ōď	*/
#endif





typedef struct{
  unsigned	char	red;			/* qʋPx 0x00`0xff	*/
  unsigned 	char	green;			/* fʋPx 0x00`0xff	*/
  unsigned	char	blue;			/* aʋPx 0x00`0xff	*/
  unsigned 	char	padding;
} SYSTEM_PALETTE_T;


int	graphic_system_init( void );
void	graphic_system_term( void );
void	graphic_system_restart( int redraw_flag );

void	put_image( void );
void	trans_palette( SYSTEM_PALETTE_T syspal[] );

void	set_mouse_visible( void );
void	set_mouse_invisible( void );




#endif	/* GRAPH_H_INCLUDED */
