/************************************************************************/
/*									*/
/* j[[hɂʂ̕\					*/
/*									*/
/* QUASI88  j[[hł̉ʕ\ɂ́Aȉ̊֐pB	*/
/* ȂÅ֐́A Q8TK ĂяoB		*/
/*									*/
/*									*/
/* y֐z								*/
/*									*/
/* voie	menu_draw( void )						*/
/*	Ej[ʂ̕\B[N T_MENU_SCREEN menu_screen[][] 	*/
/*	  āAscreen_buf ɃC[W쐬Apbgݒ肵āA	*/
/*	  \ (menu_draw_screen()) B				*/
/*									*/
/* void menu_draw_screen( void )					*/
/*	Ej[ʂ\ (screen_buf \)B			*/
/*	 uʘIoɂĕ`v̍ۂɂĂ΂B			*/
/*									*/
/*									*/
/* y\́E[Nz							*/
/*									*/
/* typedef struct{							*/
/*   Uint background:	4;	wipbgR[h (0`15)		*/
/*   Uint foreground:	4;	\pbgR[h (0`15)		*/
/*   Uint reverse:	1;	]\	ʏ=0 ]=1		*/
/*   Uint underline:	1;	A_[C	Ȃ=0 =1		*/
/*   Uint font_type:	2;	tHg^Cv (Q)			*/
/*   Uint addr:		16;	ROM AhX			*/
/* } T_MENU_SCREEN;							*/
/*									*/
/* enum FontType{		menu_screen[][].font ̒l 		*/
/*   FONT_ANK,			ASCII (Alphabet, Number, Kana etc)	*/
/*   FONT_LOW,			  ()				*/
/*   FONT_HIGH,			  (E)				*/
/*   EndofFontType							*/
/* };									*/
/*									*/
/*	j[ʂ̃[N menu_screen[25][80] ̍\̂łB	*/
/*	j[ʂ́A80~25sō\ĂA1ɁA	*/
/*	T_MENU_SCREEN ^̃[N1A蓖ĂĂB		*/
/*									*/
/*	eX̃öӖ́AɏĂƂB			*/
/*									*/
/*	ۂɕ\镶́Aaddr (ROMAhX) ŎĂ邪	*/
/*	font_type ɂāA addr ̈ӖقȂBȂ킿A	*/
/*									*/
/*	font_type   tHg						*/
/*	---------   ---------------------------------------------------	*/
/*	FONT_ANK    font_rom[addr]  8 oCg			*/
/*	FONT_LOW    addr < 0x0800 ̏ꍇ (p)				*/
/*		    Ekanji_rom[0][addr][0]  16 oCg		*/
/*		    addr < 0xc000 ̏ꍇ (1/4p)			*/
/*		    Ekanji_rom[0][addr][0]  8 oCg		*/
/*		    ȊȌꍇ       (Sp)				*/
/*		    Ekanji_rom[0][addr][0]  1oCg16 oCg	*/
/*	FONT_HIGH   kanji_rom[0][addr+1][0]  1oCg16 oCg	*/
/*									*/
/*	A\tHg̃rbgp^[ƂȂB			*/
/*	܂AQUASI88  ʂ 640x400 hbg Ȃ̂ŁA80~25s	*/
/*	ꍇA1  8x16 hbgƂȂB	ȂAFONT_ANK A	*/
/*	FONT_LOW  0x0800 <= addr < 0xc000 ̏ꍇ́Arbgp^[	*/
/*	f[^ 8x8 ƁAȂ̂ŁAcɊg債ĕ\Kv	*/
/*	B							*/
/*									*/
/************************************************************************/

#include <string.h>

#include "quasi88.h"
#include "menu-screen.h"

#include "q8tk.h"
#include "graph.h"
#include "memory.h"



#define	FULL
#define	TYPE	bit8
#include "menu-screen-draw.h"
INLINE	menu2pixel( full, bit8 )
#undef	TYPE
#define	TYPE	bit16
#include "menu-screen-draw.h"
INLINE	menu2pixel( full, bit16 )
#undef	TYPE
#define	TYPE	bit32
#include "menu-screen-draw.h"
INLINE	menu2pixel( full, bit32 )
#undef	TYPE
#undef	FULL
#define	HALF
#define	TYPE	bit8
#include "menu-screen-draw.h"
INLINE	menu2pixel( half, bit8 )
#undef	TYPE
#define	TYPE	bit16
#include "menu-screen-draw.h"
INLINE	menu2pixel( half, bit16 )
#undef	TYPE
#define	TYPE	bit32
#include "menu-screen-draw.h"
INLINE	menu2pixel( half, bit32 )
#undef	TYPE
#undef	HALF
#define	DOUBLE
#define	TYPE	bit8
#include "menu-screen-draw.h"
INLINE	menu2pixel( double, bit8 )
#undef	TYPE
#define	TYPE	bit16
#include "menu-screen-draw.h"
INLINE	menu2pixel( double, bit16 )
#undef	TYPE
#define	TYPE	bit32
#include "menu-screen-draw.h"
INLINE	menu2pixel( double, bit32 )
#undef	TYPE
#undef	DOUBLE


static	void	menu_set_screen( void )
{
  if( screen_size == SCREEN_SIZE_FULL ){		/* Full Size */
    if     ( DEPTH<= 8 ) menu2pixel_full_bit8();
    else if( DEPTH<=16 ) menu2pixel_full_bit16();
    else                 menu2pixel_full_bit32();
  }else if( screen_size == SCREEN_SIZE_HALF ){		/* Half Size */
    if     ( DEPTH<= 8 ) menu2pixel_half_bit8();
    else if( DEPTH<=16 ) menu2pixel_half_bit16();
    else                 menu2pixel_half_bit32();
  }else{						/* Double Size */
    if     ( DEPTH<= 8 ) menu2pixel_double_bit8();
    else if( DEPTH<=16 ) menu2pixel_double_bit16();
    else                 menu2pixel_double_bit32();
  }
}


/********************************************************/
/* j[\ppbg ̓e X̃pbgɓ] 	*/
/*	graph.c  set_palette() Ƃɍ쐬		*/
/********************************************************/
static	void	menu_set_palette( void )
{
  int     i;
  SYSTEM_PALETTE_T	syspal[16];

  static const struct {
    int pal;
    int col;
  } pal[ 16 ] = {
    { Q8GR_PALETTE_FOREGROUND, MENU_COLOR_FOREGROUND,	},
    { Q8GR_PALETTE_BACKGROUND, MENU_COLOR_BACKGROUND,	},
    { Q8GR_PALETTE_LIGHT,      MENU_COLOR_LIGHT,	},
    { Q8GR_PALETTE_SHADOW,     MENU_COLOR_SHADOW,	},
    { Q8GR_PALETTE_FONT_FG,    MENU_COLOR_FONT_FG,	},
    { Q8GR_PALETTE_FONT_BG,    MENU_COLOR_FONT_BG,	},
    { Q8GR_PALETTE_SCALE_SLD,  MENU_COLOR_SCALE_SLD,	},
    { Q8GR_PALETTE_SCALE_BAR,  MENU_COLOR_SCALE_BAR,	},
    { Q8GR_PALETTE_SCALE_ACT,  MENU_COLOR_SCALE_ACT,	},
    { Q8GR_PALETTE_DUMMY_09,   0x000000,		},
    { Q8GR_PALETTE_DUMMY_10,   0x000000,		},
    { Q8GR_PALETTE_DUMMY_11,   0x000000,		},
    { Q8GR_PALETTE_DUMMY_12,   0x000000,		},
    { Q8GR_PALETTE_DUMMY_13,   0x000000,		},
    { Q8GR_PALETTE_DUMMY_14,   0x000000,		},
    { Q8GR_PALETTE_DUMMY_15,   0x000000,		},
  };

  for( i=0; i<countof(pal); i++ ){
    syspal[ pal[i].pal ].red   = (pal[i].col >> 16) & 0xff;
    syspal[ pal[i].pal ].green = (pal[i].col >>  8) & 0xff;
    syspal[ pal[i].pal ].blue  = (pal[i].col >>  0) & 0xff;
  }


  trans_palette( syspal );
}

/********************************************************/
/* oオʃC[Wۂɕ\			*/
/********************************************************/
void	menu_redraw_screen( void )
{
  put_image();
}


/********************************************************/
/* Q8TK Ă΂֐AR			*/
/********************************************************/
void	menu_draw_screen( void )
{
  menu_set_palette();
  menu_set_screen();
  menu_redraw_screen();
}
