#ifndef QUASI88_H_INCLUDED
#define QUASI88_H_INCLUDED


/*----------------------------------------------------------------------*/
/* SDLɊւ`							*/
/*----------------------------------------------------------------------*/

#ifdef HAVE_SDL
#include <SDL_main.h>
#include <SDL_byteorder.h>


/* GfBAlX`FbN */
#if	( SDL_BYTEORDER == SDL_LIL_ENDIAN )
#define	LSB_FIRST
#endif

/* select()g킯ł͂ȂAmsPʂ sleep \Ȃ̂Œ`Ƃ */
#define	HAVE_SELECT

/* X11-DGA g킯ł͂ȂAtXN[ؑւ\Ȃ̂Œ`Ƃ */
#define	USE_DGA

/* SDL QUASI88 ̂߂̎ʗp */

#define	USE_SDL

#endif


/* ^Cgƃo[W */
#ifndef	Q_TITLE
#define	Q_TITLE		"QUASI88(SDL)"
#endif
#ifndef	Q_VERSION
#define	Q_VERSION	"0.5.5s1"
#endif

/* PI()  M_PI() ` */
#ifndef	UNIX88
#ifndef PI
#define PI 3.14159265358979323846
#endif
#ifndef	M_PI
#define	M_PI	PI
#endif
#endif

/* WCXeBbN */
#define	USE_JOY
#define	USE_JOY_SDL

/*
  MAME/XMAME ̃TEhgݍޏꍇA
	USE_SOUND
  `ĂB

  FMGEN gݍޏꍇ́A
	USE_FMGEN
  `ĂB

  ĹARpCɈȉ̂悤ɂĒ`B
  gcc  ̏ꍇARpCɃIvV -DUSE_SOUND   ȂǂƎw肷B
  VC++ ̏ꍇARpCɃIvV /D"USE_SOUND" ȂǂƎw肷B
  MWP  ̏ꍇARpCɃIvV -d USE_SOUND  ȂǂƎw肷B
*/




/*
 *	VC++ depend
 */

#ifdef _MSC_VER

/* VC ̃CCL[[h */
#define	INLINE		__inline

#endif

#if	(_MSC_VER) || (__MINGW32__)

/* Windows QUASI88 ̂߂̎ʗp */
#define	WIN88

/* pXEt@C̍ő咷 ? */
#define	OSD_MAX_FILENAME	(240)

#endif

#define EXPRINTF(format,...) \
{ printf(format,## __VA_ARGS__); } 

/*
 *
 */

#ifndef	BIT32
#define	BIT32		int
#endif


/*----------------------------------------------------------------------*/
/* ʒ`								*/
/*----------------------------------------------------------------------*/

typedef	unsigned char	Uchar;
typedef	unsigned short	Ushort;
typedef	unsigned int	Uint;
typedef	unsigned long	Ulong;

typedef unsigned char  byte;
typedef unsigned short word;
typedef signed   char  offset;


typedef unsigned char  bit8;
typedef unsigned short bit16;
typedef unsigned BIT32 bit32;


#define	countof(arr)	(int)(sizeof(arr)/sizeof((arr)[0]))


#ifdef LSB_FIRST			/* gGfBA */

typedef union
{
  struct { byte l,h; }	B;
  word			W;
} pair;

#else					/* rbOGfCA */

typedef union
{
  struct { byte h,l; }	B;
  word			W;
} pair;

#endif



#ifndef TRUE
#define	TRUE	(1)
#endif
#ifndef FALSE
#define	FALSE	(0)
#endif



#ifndef	INLINE
#define	INLINE	static
#endif



/*----------------------------------------------------------------------*/
/* ϐ (verbose_*)A֐						*/
/*----------------------------------------------------------------------*/
extern	int	verbose_level;		/* 璷x			*/
extern	int	verbose_proc;		/* ̐is󋵂̕\		*/
extern	int	verbose_z80;		/* Z80G[\		*/
extern	int	verbose_io;		/*  I/OANZX	*/
extern	int	verbose_pio;		/* PIO ̕sgp\		*/
extern	int	verbose_fdc;		/* FDC[Wُ		*/
extern	int	verbose_wait;		/* EGCg҂ُ̈	*/
extern	int	verbose_suspend;	/* TXyḧُ	*/
extern	int	verbose_snd;		/* TEh̃bZ[W		*/


void	main_exit( int val );
void	main_reset( void );



/*----------------------------------------------------------------------*/
/*	fobOpɉʂt@CɃOo (xቺ܂)	*/
/*----------------------------------------------------------------------*/

/*#define PIO_DISP*/		/* PIO ֌W̃Oʂɕ\     */
/*#define PIO_FILE*/		/*		   t@Cɏo */

/*#define FDC_DISP*/		/* FDC ֌W̃Oʂɕ\     */
/*#define FDC_FILE*/		/*		   t@Cɏo */

/*#define MAIN_DISP*/		/* C Z80 ֌W̃Oʂɕ\ */
/*#define MAIN_FILE*/		/*		   t@Cɏo    */

/*#define SUB_DISP*/		/* Tu Z80 ֌W̃Oʂɕ\ */
/*#define SUB_FILE*/		/*		   t@Cɏo  */


#ifndef	USE_MONITOR
#undef PIO_DISP
#undef PIO_FILE
#undef FDC_DISP
#undef FDC_FILE
#undef MAIN_DISP
#undef MAIN_FILE
#undef SUB_DISP
#undef SUB_FILE
#endif


/* Ot@CɎꍇ́At@CJ */
#if defined(PIO_FILE) || defined(FDC_FILE) || defined(MAIN_FILE) || defined(SUB_FILE)
#include <stdio.h>
extern	FILE	*LOG;
#endif


/* Oo͂̃}N							*/
/*	Eϒ̊֐Ăяo}NłB			*/
/*	E}N̂̂𖳌ɂɂ́Aʂɂ			*/
/*		#define  logxxx   (void)				*/
/*		#define  logxxx   if(1){}else printf			*/
/*	ȂǂgBO҂ł̓[jOo鎞̂Ō҂̗pB*/


#if	defined( PIO_DISP ) || defined( PIO_FILE )
void	logpio( const char *format, ... );
#else
#define	logpio	if(1){}else printf
#endif

#if	defined( FDC_DISP ) || defined( FDC_FILE )
void	logfdc( const char *format, ... );
#else
#define	logfdc	if(1){}else printf
#endif

#if	defined( MAIN_DISP ) || defined( MAIN_FILE ) || defined( SUB_DISP ) || defined( SUB_FILE )
void	logz80( const char *format, ... );
#else
#define	logz80	if(1){}else printf
#endif



#endif		/* QUASI88_H_INCLUDED */
